<?php
/**
 * Perforce Swarm
 *
 * @copyright   2013-2018 Perforce Software. All rights reserved.
 * @license     Please see LICENSE.txt in top-level readme folder of this distribution.
 * @version     2018.2/1705499
 */

namespace Application\Permissions;

use Reviews\Model\Review;
use Zend\ServiceManager\ServiceLocatorInterface as ServiceLocator;

class Reviews
{

    protected $serviceLocator = null;

    /**
     * Ensure we get an admin connection and username of the user to check projects access for on construction.
     *
     * @param   ServiceLocator           $serviceLocator  the service locator to use
     */
    public function __construct(ServiceLocator $serviceLocator)
    {
        $this->serviceLocator = $serviceLocator;
    }

    /**
     * Check if the user can access the head change of the review and also the projects on the review.
     *
     * @param Review $review This is a review
     *
     * @return bool
     */
    public function canAccessChangesAndProjects(Review $review)
    {

        $change  = $this->serviceLocator->get('changes_filter')->canAccess($review->getHeadChange());
        $project = $this->serviceLocator->get('projects_filter')->canAccess($review);

        if ($change && $project) {
            return true;
        }
        return false;
    }
}
